;HHC code disassembled from hex dump by Herb Johnson 
; last date May 20 7 PM EDT
;disasm aided by 1806 disassembler (c)1998 Herman Robers PA3FYW
;annotated with FORTH source & info obtained from (c) S Robson 1981,2016
;comments from Robson edited by HRJ based on this source.
;additional corrections from Lee Hart and Robson.
;
;Forth virtual machine register allocation
;  R3 - s parameter stack  (the 'X' register is setup with a SEX 3 instruction)
;  R4 - r return stack 
;  R5 - i (interpreter pointer)
;  R6 - w (current 'word' pointer)
;  R8 - address of 'next', the inner interpreter
;  R9 - program counter
;  RA, RB, RC - temp storage
;
;Header structure
;the word header structure is based on the Forth-79 dictionary model:-
;byte 1         - length L of word name (msb set)   [NFA]
;byte 2..       - name bytes (final byte indicated by msb set)
;byte L+2    - 2byte link to NFA of previous named word in dict  [LFA]
;byte L+4    - 2byte pointer to code definition for this word  [CFA]
;byte L+6... - threaded list of 'word' addr or param(s) for def [PFA]
;
;Headerless structure
;byte 1    - 2byte pointer to code def  for this word  [CFA]
;byte 3... - threaded list of 'word' addr or param(s) for def [PFA]
;
;Forth dictionary words used
;standard Forth-79 words included in the monitor ROM dump:-
;     + -  = > 0 2* 2/ @ and bl c@ c! drop dup not over rot swap
;     many more words available see source
;
    incl "1802reg.asm"
    org 0000h
    dis            ; Disable. Return from interrupt, set IE=0
    db 00h         ; since X=PC=0, this becomes an operand byte
    lbr SETUP      ; Long branch to init code
    sep r9         ; Set P=R9 as program counter to interpret word
Inext:              ; 
    lda r5         ; R5 is i, interpreter pntr
    phi r6         ; R6 is w, current word pntr
    lda r5         ;  
    plo r6         ;  
    lda r6         ; R6 is w
    phi r9         ; R9 is Forth pgm counter
    lda r6         ; advance w to next word
    plo r9         ; Forth pgm counter -> next word
    br low Inext-1     ; branch to interpret word, return to inner
;edit the adresses in locations 12h-1Dh to customise the ROM dump for a new system.
; The 2-byte locations should be filled as follows:-
; [0010 - Monitor PFA (already contains  0309h, the monitor start address) ]
;  0012 - Parameter stack (top address)
;  0014 - Return stack (top address)
;  0016 - 'key' CFA ( read 8bit ASCII value and place on top of stack)
;  0018 - 'emit' CFA ( take 8bit ASCII value from stack and write to display)
;  001A - 'page' CFA ( clear screen / form feed printer / scroll display etc)
;  001C - 'init' CFA ( initialise I/O hardware)
;  001E - <reserved>
params: DW mon+2   ;Monitor PFA at 0307 + 2 = 0309h
  	DW 0000h       ;parameter stack (top address)
  	DW 0000h       ;Return stack (top address)
  	DW 0000h       ;'key' CFA
  	DW 0000h       ;'emit' CFA
  	DW 0000h       ;'page' CFA
  	DW 0000h       ;'init' CFA
  	DW 0000h       ;reserved

SETUP:             ; set up Forth registers 
    ldi high xxxx  ;  
    phi r9         ;  
    ldi low xxxx   ;  
    plo r9         ; Forth program counter
    sep r9         ; Set P=R9 as program counter
xxxx:
    ldi high params  ;  
    phi r6         ; init R6 
    ldi low params   ; to initial locations table
    plo r6         ; R6 is w (current 'word' pointer)
    lda r6         ; Load D from (R6), increment R6
    phi r5         ; 
    lda r6         ; init R5 from locs table
    plo r5         ; R5 is i (interpreter pointer)
    lda r6         ; Load D from (R6), increment R6
    phi r3         ; Put high register R3
    lda r6         ; init R3 from locs table
    plo r3         ; R3 <- X = s parameter stack  
    sex r3         ; Set P=R3 as X datapointer
    lda r6         ; Load D from (R6), increment R6
    phi r4         ; init R4 from locs table
    lda r6         ;
    plo r4         ; R4  is r return stack 
    ldi high Inext ;  
    phi r8         ; init R8  
    ldi low Inext  ;  
    plo r8         ; R8 address of 'next', the inner interpreter
    seq            ; Set Q=1
    sep r8         ; jump to next
                   ; and run inner interpreter now
;
; hcode section
;
;DOCOL  or nest, pushes i on return stack, i set to current word w, next
;(runtime machine code for ':' defns.)
    dw $+2         ; point to code below
DOCOL:
    glo r5         ; R5 is i interp pointer
    dec r4         ; adjust R4 return stack
    str r4         ; Store D to (R4)
    ghi r5         ; Get high register R5
    dec r4         ; Decrement (R4)
    str r4         ; set return stack up
    glo r6         ; R6 is current 'word' pointer)
    plo r5         ; R5 is i interp pointer
    ghi r6         ;  
    phi r5         ; set interp pntr up
    sep r8         ; jump to next
    ;  $+2
;DOCON or const, gets w current word, pushes into param stack, next
;(runtime machine code for 'CONSTANT' defns.) 
    dw $+2         ; point to code below
DOCON:
    lda r6         ; R6 is w, current word addr, incr
    phi ra         ; save in  RA
    lda r6         ; Load D from (R6), increment R6
    dec r3         ; Decrement (R3), param stack
    stxd           ; Store via X (param stack) and decrement
    ghi ra         ; Get from RA
    str r3         ; Store D to (R3)
    sep r8         ; jump to next
    ;
;';s' (un-nest) pops from return stack into i, next
semis:
    dw $+2         ; point to code below
    lda r4         ; Load D from (R4) return stack, inc  R4
    phi r5         ; Put high register R5, i inter pntr
    lda r4         ; Load D & incr
    plo r5         ; Put  
    sep r8         ; jump to next
  ;
;execute  pops param stack to w (current word), jump inside "next"
xeq:
    dw $+2         ; point to code below
    ldxa           ; Load via X (param stack) and advance
    phi r6         ; Put high register R6
    ldxa           ; Load via X and advance
    plo r6         ; R6 (w) has value from param stack
    ldi high (Inext+4) ; addr inside inner interp?
    phi ra         ; Put high register RA
    ldi low (Inext+4) ; address inside inner interp?
    plo ra         ; Put low register RA
    sep ra         ; jump inside inner interp?
    ;
;branch loads i with word it points to, next
branch:
    dw $+2         ; point to code below
    lda r5         ; Load D from (R5), inter. pointer i & incr
    phi ra         ; Put high register RA
    lda r5         ; Load D from (R5), increment R5
    plo r5         ; Put low register R5
    ghi ra         ; Get high register RA
    phi r5         ; Put high register R5
    sep r8         ; jump to next
;
;branch0? pop param stack, if zero jump to 006fh (branch), else advance i, next
branch0:
    dw $+2         ; point to code below
    ldxa           ; Load via X (param stack) and advance
    or             ; Logical OR  D with (R(X))
    irx            ; Increment register X
    lbz branch      ; Long branch on D=0
    inc r5         ; Increment (R5)
    inc r5         ; Increment (R5)
    sep r8         ; jump to next
    ;
 ;lit i pushed on parma stack, next
_lit:
    dw $+2         ; point to code below
    lda r5         ; Load D from (R5) interp, and incr R5
    phi ra         ; save in  RA
    lda r5         ; Load D from (R5), increment R5
    dec r3         ; Decrement (R3), param stack
    stxd           ; Store via X and devrement
    ghi ra         ; Get from  RA
    str r3         ; Store D to (R3) param stack
    sep r8         ; jump to next
    ;
    ; code section begins
    ;

    db 80H+3       ;msb set, length byte
    db 'no',80H+'t'  ;code name, LSB on last bit       
    dw 0000h       ; null link no previous named word
_not:
    dw $+2          ; link to code def, immediately below
    ldi 00         ; Load D immediate
    plo ra         ; Put low register RA
    ldxa           ; Load via X and advance
    or             ; Logical OR  D with (R(X))
    lbnz notthen   ; Long branch on D!=0
    ldi 01         ; Load D immediate
    plo ra         ; Put low register RA
notthen:
    glo ra         ; Get low register RA
    stxd           ; Store via X and devrement
    str r3         ; Store D to (R3)
    sep r8         ; jump to next
    ;
    db 80H+4       ;msb set, length byte
    db 'ove',80h+'r' ; name bytes
    dw 008bh       ; link to previous word
_over:
    dw $+2         ; link to code below
    irx            ; Increment register X
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldx            ; Pop stack. Place value in D register
    dec r3         ; Decrement (R3)
    dec r3         ; Decrement (R3)
    dec r3         ; Decrement (R3)
    dec r3         ; Decrement (R3)
    stxd           ; Store via X and devrement
    ghi ra         ; Get high register RA
    str r3         ; Store D to (R3)
    sep r8         ; jump to next
    ;
    db 80h+4	   ;length byte
    db 'swa',80h+'p' ; swap
    dw 00a2h       ;previous word
_swap:
    dw $+2          ;link to code below
    ldxa           ; Load via X and advance
    phi ra    
    ldxa           ; Load via X and advance
    plo ra         ; Put low register RA
    ldxa           ; Load via X and advance
    phi rb         ; Put high register RB
    ldx            ; Pop stack. Place value in D register
    plo rb         ; Put low register RB
    glo ra         ; Get low register RA
    stxd           ; Store via X and devrement
    ghi ra         ; Get high register RA
    stxd           ; Store via X and devrement
    glo rb         ; Get low register RB
    stxd           ; Store via X and devrement
    ghi rb         ; Get high register RB
    str r3         ; Store D to (R3)
    sep r8         ; jump to next
    ;
    db 80h+2       ;length byte   HRJ not in FORTH source
    db 'b',80H+'l' ;bl
    dw 00b8h       ; previous word
_bl:
    dw DOCON       ; code def
    dw 0020h       ;push ASCII blank on param stack
    ;
    db 80h+1       ;length byte  HRJ not in FORTH source
    db 80h+'0'     ; 0  
    dw 00d2h       ; previous word 
_zero:
    dw DOCON       ; code def
    dw 0000h       ; push null on param stack
    ;
    db 80h+3
    db 'ro',80h+'t' ;rot
    dw 00dbh       ; pointer to previous word
_rot:
    dw $+2         ; point to code below
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldxa           ; Load via X and advance
    plo ra         ; Put low register RA
    ldxa           ; Load via X and advance
    phi rb         ; Put high register RB
    ldxa           ; Load via X and advance
    plo rb         ; Put low register RB
    ldxa           ; Load via X and advance
    phi rc         ; Put high register RC
    ldx            ; Pop stack. Place value in D register
    plo rc         ; Put low register RC
    glo rb         ; Get low register RB
    stxd           ; Store via X and devrement
    ghi rb         ; Get high register RB
    stxd           ; Store via X and devrement
    glo ra         ; Get low register RA
    stxd           ; Store via X and devrement
    ghi ra         ; Get high register RA
    stxd           ; Store via X and devrement
    glo rc         ; Get low register RC
    stxd           ; Store via X and devrement
    ghi rc         ; Get high register RC
    str r3         ; Store D to (R3)
    sep r8         ; jump to next
   ;
    db 80H+3       ;length byte
    db 'an',80H+'d' ;and
    dw 00e3h       ;previous word
_and:
    dw $+2          ;point to code below
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldxa           ; Load via X and advance
    irx            ; Increment register X
    and            ; Logical AND: D with (R(X))
    stxd           ; Store via X and devrement
    ghi ra         ; Get high register RA
    and            ; Logical AND: D with (R(X))
    str r3         ; Store D to (R3)
    sep r8         ; jump to next
    ;
    db 80H+4       ;length byte
    db 'dro',80H+'p' ;drop   
    dw 0104h       ;prev word
_drop:
    dw $+2         ;point to code below
    irx            ; Increment register X
    irx            ; Increment register X
    sep r8         ; jump to next
    ;
    db 80h+3       ;length byte
    db 'du',80h+'p'   ;dup
    dw 0116h       ;prev word
_dup:
    dw $+2         ; point to code below
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldx            ; Pop stack. Place value in D register
    dec r3         ; Decrement (R3)
    dec r3         ; Decrement (R3)
    stxd           ; Store via X and devrement
    ghi ra         ; Get high register RA
    str r3         ; Store D to (R3)
    sep r8         ; jump to next
   ;
    db 80h+2       ;length byte
    db 'c',80h+'@' ;c@
    dw 0122h       ;prev word
_cat:
    dw $+2        ; point to code below
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldx            ; Pop stack. Place value in D register
    plo ra         ; Put low register RA
    ldn ra         ; Load D with (RA)
    stxd           ; Store via X and devrement
    ldi 00         ; Load D immediate
    str r3         ; Store D to (R3)
    sep r8         ; jump to next
 ;
    db 80h+2       ;length byte
    db 'c',80h+'!'
    dw 0133h      ;prev word
_cbang:
    dw $+2         ; point to code below
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldxa           ; Load via X and advance
    plo ra         ; Put low register RA
    irx            ; Increment register X
    ldxa           ; Load via X and advance
    str ra         ; Store D to (RA)
    sep r8         ; jump to next
 ;
    db 80h+1       ;length byte  (hrj not in FORTH source)
    db 80h+'@'    ;@
    dw 0144h       ; prev word
_at:
    dw $+2         ; point to code below
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldx            ; Pop stack. Place value in D register
    plo ra         ; Put low register RA
    lda ra         ; Load D from (RA), increment RA
    phi rb         ; Put high register RB
    ldn ra         ; Load D with (RA)
    stxd           ; Store via X and devrement
    ghi rb         ; Get high register RB
    str r3         ; Store D to (R3)
    sep r8         ; jump to next
;
    db 80h+1       ;length byte
    db 80h+'+'     ;+
    dw 0153h       ; prev word
_plus:
    dw $+2         ; point to code below
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldxa           ; Load via X and advance
    irx            ; Increment register X
    add            ; Add D: D,DF= D+(R(X))
    stxd           ; Store via X and devrement
    ghi ra         ; Get high register RA
    adc            ; Add with carry
    str r3         ; Store D to (R3)
    sep r8         ; jump to next
  ;
    db 80h+1       ;length byte
    db 80h+'-'     ;-
    dw 0164h      ; prev word
_minus:
    dw $+2         ; point to code below
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldxa           ; Load via X and advance
    irx            ; Increment register X
    sd             ; Substract D: D,DF=(R(X))-D
    stxd           ; Store via X and devrement
    ghi ra         ; Get high register RA
    sdb            ; Subtract D with borrow
    str r3         ; Store D to (R3)
    sep r8         ; jump to next
  ;
    db 80h+1       ;length byte
    db 80h+'>'     ;>
    dw 0174h     ; prev word
_gt:
    dw $+2          ; point to code below
    ldi 00         ; Load D immediate
    plo rc         ; Put low register RC
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldxa           ; Load via X and advance
    irx            ; Increment register X
    sm             ; Substract memory: DF,D=D-(R(X))
    dec r3         ; Decrement (R3)
    ldn r3         ; Load D with (R3)
    phi rb         ; Put high register RB
    ghi ra         ; Get high register RA
    smb            ; Substract memory with borrow
    ani 80H        ; Logical AND D with value
    phi rc         ; Put high register RC
    lbz gtthen     ; Long branch on D=0
    inc rc         ; Increment (RC)
gtthen:
    glo rc         ; Get low register RC
    irx            ; Increment register X
    stxd           ; Store via X and devrement
    ldi 00         ; Load D immediate
    stxd           ; Store via X and devrement
    ghi ra         ; Get high register RA
    str r3         ; Store D to (R3)
    ghi rb         ; Get high register RB
    xor            ; Logical exclusive OR  D with (R(X))
    stxd           ; Store via X and devrement
    ghi rc         ; Get high register RC
    str r3         ; Store D to (R3)
    ghi ra         ; Get high register RA
    xor            ; Logical exclusive OR  D with (R(X))
    irx            ; Increment register X
    and            ; Logical AND: D with (R(X))
    ani 80H        ; Logical AND D with value
    irx            ; Increment register X
    lbz gt2then    ; Long branch on D=0
    irx            ; Increment register X
    ldi 01         ; Load D immediate
    xor            ; Logical exclusive OR  D with (R(X))
    stxd           ; Store via X and devrement
gt2then:
    sep r8         ; jump to next
   ;
    db 80h+2      ;length byte
    db '2',80h+'*'   ;2*
    dw 0184h     ; prev word
_2times:
    dw $+2         ; point to code below
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldx            ; Pop stack. Place value in D register
    shl            ; Shift left D
    stxd           ; Store via X and devrement
    ghi ra         ; Get high register RA
    shlc           ; Shift left with carry
    str r3         ; Store D to (R3)
    sep r8         ; jump to next
  ;
   db 80h+2      ;length byte
   db '2',80H+'/'   ;2/
   dw 01bbh       ; prev word
_2slash:
    dw $+2          ; point to code below
    ldxa           ; Load via X and advance
    shr            ; Shift right D
    phi ra         ; Put high register RA
    ldx            ; Pop stack. Place value in D register
    shrc           ; Shift right with carry
    stxd           ; Store via X and devrement
    ghi ra         ; Get high register RA
    str r3         ; Store D to (R3)
    sep r8         ; jump to next
   ;
    db 80h+1      ;length byte
    db 80H+'='      ;=
    dw 01cbh       ; prev word
_equ:
    dw $+2        ; point to code below
    ldi 00         ; Load D immediate
    plo r6         ; Put low register R6
    ldxa           ; Load via X and advance
    phi ra         ; Put high register RA
    ldxa           ; Load via X and advance
    irx            ; Increment register X
    xor            ; Logical exclusive OR  D with (R(X))
    lbnz eq1th   ; Long branch on D!=0
    dec r3         ; Decrement (R3)
    ghi ra         ; Get high register RA
    xor            ; Logical exclusive OR  D with (R(X))
    irx            ; Increment register X
    lbnz eq2th   ; Long branch on D!=0
    ldi 01         ; Load D immediate
    plo r6         ; Put low register R6
eq2th:
eq1th:
    glo r6         ; Get low register R6
    stxd           ; Store via X and devrement
    ldi 00         ; Load D immediate
    str r3         ; Store D to (R3)
    sep r8         ; jump to next
    ;
REBOOT:
    dw $+2       ; point to code below
    lbr 0002h	 ; long branch to restart
    ;
    ;hardware related words
    ;
    db 80H + 3     ;length byte (FORTH source different)
    db 'ke',80H+'y' ;key
    dw 01dbh       ; prev word
_key:
    dw DOCOL       ;links to code for DOCOL
    dw _lit       ;lit
    dw params + 6h ;addr of table for key CFA
    dw _at       ;_at
    dw xeq	;xeq
    dw semis	;semis
   ;
    db 80H + 4     ; length byte (FORTH source different)
    db 'emi',80h+'t';emit
    dw 0201h       ; previouss word
_emit:
    dw DOCOL       ; links to code for DOCOL
    dw _lit       ;lit
    dw params + 8h	;addr of table for emit CFA
    dw _at	;_at
    dw xeq	;xeq
    dw semis	;semis
   ;
   ;last (first) word with full header
   ;
    db 80H+4       ;length byte  (FORTH source different)
    db 'pag',80H+'e' ;page
    dw 0213h      ;previous word
_page:
    dw DOCOL     ; link to nest code
    dw _lit      ;literal
    DW params + 0Ah	;addr of table for page CFA 
    DW _at	;_at
    dw xeq	;xeq
    dw semis	;semis
; 
;following was hand-disassembled 

               ; Threaded-code definition section
INIT:          ; perform any h/w i/o initialisation
    dw DOCOL
    dw _lit 
    dw params + 0CH	;addr of table for init CFA
    dw _at 

    DW xeq
    DW semis
          ;
INVAL:	; wait for & convert ASCII hex digits from k/b to hex integer value
L0245:
    DW DOCOL
    DW _zero 
    DW _dup 
L024B:
    DW _key	; get ASCII value
    DW _dup 
    DW _lit
    DW 001BH	;escape char 
    DW _equ 
    DW branch0 
    DW L025B
    DW REBOOT	; restart MON if 'Esc' key pressed
L025B:
    DW _dup
    DW _lit
    DW 001FH	;value

    DW _gt 	;value below 1F, exit
    DW branch0 
    DW L029B
    DW _dup 
    DW _emit 	;echo
    DW _dup 
    DW _lit 
    DW 0039H	;char 9?

    DW _gt 
    DW branch0 
    DW L027D
    DW _lit 
    DW 0007H	;sub value 7
    DW _minus
L027D: 
    DW _lit 
    DW 0030H	;char 0? 

    DW _minus 
    DW _rot 
    DW _2times 
    DW _2times 
    DW _2times 
    DW _2times	;convert to hex 
    DW _plus 
    DW _swap	;
 
    DW _lit 
    DW 0001		;value
    DW _plus 	;increment something
    DW branch 
    DW L024B	;get another key
L029B:
    DW _drop 
    DW _dup 
    DW _not

    DW branch0 
    DW L02A7
    DW _drop 
L02A7:
    DW _bl 
    DW _emit 
    DW semis

HEXOUT:		; o/p a hex integer as ASCII hex digits
L02AD: 
    DW DOCOL 
    DW _zero

    DW _rot 
    DW _rot
L02B5:  
    DW _swap
    DW _dup 
    DW _lit 
    DW 000Fh	;value
    DW _and 
    DW _dup

    DW _lit 
    DW 0009h	;value
     DW _gt 
    DW branch0 
    DW L02D1
    DW _lit 
    DW 0007h	;value
    DW _plus
L02D1: 
    DW _lit 
    DW 0030h	;space?
    DW _plus 
    DW _swap 
    DW _2slash 
    DW _2slash 
    DW _2slash 
    DW _2slash

    DW _rot 
    DW _lit 
    DW 0001h	;one
    DW _minus 
    DW _dup 
    DW _not 
    DW branch0 
    DW L02B5

    DW _drop 
    DW _drop 
L02F5:
    DW _emit 
    DW _dup 
    DW _not 
    DW branch0 
    DW L02F5
    DW _drop

    DW _bl		;o/p BL for gap after each number displayed
    DW _emit      ;(HRJ FORTH source has "20" but this is put blank 20!)
    DW semis 

mon: 
    DW DOCOL	;monitor CFA 
    DW INIT	;monitor PFA
		; Perform any i/o hardware initialisation
L030B:
    DW _page
    DW _lit 
    DB 00,'>'	;o/p '>' char as monitor prompt

    DW _emit	;prompt
    DW _key		; fetch & echo command character
    DW _dup 
    DW _emit 
    DW _dup 
    DW _lit 
    DB 00,'A'	;Check for command 'A' (as per HHC website notes) notes
    DW _equ

    DW branch0 
    DW L0357 
    DW _drop 
    DW INVAL
    DW _drop 
L032B:
    DW _page 	; display memory location & content
    DW _dup 
    DW _lit

    DW 0004h	;value 
    DW HEXOUT
    DW _dup 
    DW _cat
    DW _lit 
    DW 0002h	;value 
    DW HEXOUT
    DW INVAL

    DW branch0 
    DW L0349
    DW _over 	; update memory content if data given
    DW _cbang 
L0349:
    DW _lit 
    DW 0001h	;one 
    DW _plus 
    DW branch
    DW L032B
    DW branch 
    DW L0367
L0357:
    DW _lit 
    DW 0052h	;Check for command 'R' (as per HHC website notes)
    DW _equ 	; FORTH source uses letter 'B', other actions
    DW branch0
    DW L0367

    DW INVAL	; input a word's CFA from k/b to stack
    DW _drop 
    DW xeq 		; 'Execute' addr on stack
L0367:
    DW branch 
    DW L030B 
    DW semis
    DW 0000
    DB 00

    end


